unit u_regfbbuttons;
{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to 2016 (LAZARUS),             }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}


{$IFDEF FPC}
{$mode Delphi}
{$ENDIF}

{$I ..\DLCompilers.inc}
{$I ..\extends.inc}

interface

uses
{$IFDEF FPC}
  lresources,
{$ELSE}
  Windows,
{$ENDIF}
  SysUtils, Classes;

procedure Register;

implementation

uses u_buttons_flat;

procedure Register;
begin
  RegisterComponents('FBButtons', [TFBClose,TFBNext,TFBPrior,TFBLoad,TFBTrash,TFBConfig,
                                   {$IFDEF GROUPVIEW} TFBBasket,TFBInSelect,TFBInAll,TFBOutSelect,TFBOutAll,{$ENDIF}
                                   TFBOK,TFBInsert,TFBInit,TFBDelete,TFBDocument,TFBCancel,TFBQuit,TFBErase,TFBSaveAs,TFBAdd,TFBImport,TFBExport,TFBPrint,TFBPreview,TFBCopy]);
End ;



{$IFDEF FPC}
initialization
  {$I u_regfbbuttons.lrs}
{$ENDIF}

end.

