unit u_registerbuttons;
{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to 2016 (LAZARUS),             }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}


{$IFDEF FPC}
{$mode objfpc}{$H+}
{$ENDIF}
{$I ..\extends.inc}

interface

uses
  Classes, SysUtils;

procedure Register;

implementation

uses
  {$IFDEF FPC}
  lresources,
  {$ENDIF}
  u_ancestropictbuttons,u_ancestropictimages;

procedure Register;
begin
  RegisterComponents('Ancestro Buttons',
  [TIATitle,TXAAncestromania, TXAEMail,
   TXAFavorite,TXAHistory,TXAHuman,
   TIAHuman, TXAInfo, TIAInfo,TIAMouse,
   TXANeighbor, TXAPriorPage,TXAPrior,TXANext,TXANextPage,
   TXAPeople,TXAPostCard, TXAQuestion,
   TIAQuestion,TIASearch,
   TXAWeb, TXAWho, TIAGender,TXAWorld,TIAWorld]);
End ;


{$IFNDEF MEMBUTTONS}
{$IFDEF FPC}
initialization
  {$I u_ancestropictimages.lrs}
  {$I u_ancestropictbuttons.lrs}
  {$ENDIF}
{$ENDIF}
end.

